function [x,iter]=gausseid(a,b,x0,toll,nitmax)
% Help function jacobi
% 
% [x,iter]=gausseid(a,b,x0,toll,nitmax)
%
% Metodo di Gauss Seidel per sistemi lineari
%
% Parametri ingresso: 
%
%       a       matrice del sistema
%       b       termine noto del sistema (vettore colonna)
%       x0      vettore iniziale
%       toll    tolleranza sul test d'arresto (differenza iterate)
%       nitmax  numero max iterazioni consentite
%
% Parametri uscita:
%
%       x       soluzione approssimata (vettore colonna)       
%       iter    numero iterazioni effettuato
%
n=length(x0);
iter=0;
err=1;
x=x0;
while iter<nitmax & err>toll
	j=1;
	x(j)=(b(j)-a(j,(j+1):n)*x0((j+1):n))/a(j,j);
	for j=2:n-1
       		x(j)=(b(j)-a(j,1:(j-1))*x(1:(j-1))-a(j,(j+1):n)*x0((j+1):n))/a(j,j);
	end
	j=n;
	x(n)=(b(j)-a(j,1:(j-1))*x(1:(j-1)))/a(j,j);
        err= norm(x-x0);
        iter=iter+1;
        x0=x; 
end
if iter==nitmax & err>toll
        disp('non converge nel numero di iterazioni assegnato')
end

