function [x,iter]=grad(a,b,x0,toll,nitmax)
% Help function grad
% 
% [x,iter]=grad(a,b,x0,toll,nitmax)
%
% Metodo del Gradiente per sistemi lineari- si blocca se A non e'simm def pos
%
% Parametri ingresso: 
%
%       a       matrice del sistema
%       b       termine noto del sistema (vettore colonna)
%       x0      vettore iniziale
%       toll    tolleranza sul test d'arresto (differenza iterate)
%       nitmax  numero max iterazioni consentite
%
% Parametri uscita:
%
%       x       soluzione approssimata (vettore colonna)       
%       iter    numero iterazioni effettuato
%
if norm(a-a')>0
	disp('matrice non simm. non uso metodo Gradiente')
	break
end
lmin=min(eig(a));
if lmin <= 0
	disp('matrice non def. positiva')
	break
end
iter=0;
err=1;
while iter<nitmax & err>toll
	r=b-a*x0;
	alfa=r'*r/(r'*(a*r));
        x=x0+alfa*r;
        err= norm(x-x0);
        iter=iter+1;
        x0=x; 
end
if iter==nitmax & err>toll
        disp('non converge nel numero di iterazioni assegnato')
end

