function [x,iter]=gradcon(a,b,x0,toll,nitmax)
% Help function gradcon
% 
% [x,iter]=gradcon(a,b,x0,toll,nitmax)
%
% Metodo del Gradiente per sistemi lineari- si blocca se A non e'simm def pos
%
% Parametri ingresso: 
%
%       a       matrice del sistema
%       b       termine noto del sistema (vettore colonna)
%       x0      vettore iniziale
%       toll    tolleranza sul test d'arresto (differenza iterate)
%       nitmax  numero max iterazioni consentite
%
% Parametri uscita:
%
%       x       soluzione approssimata (vettore colonna)       
%       iter    numero iterazioni effettuato
%
if norm(a-a')>0
	disp('matrice non simm. non uso metodo Gradiente')
	break
end
lmin=min(eig(a));
if lmin <= 0
	disp('matrice non def. positiva')
	break
end
iter=0;
err=1;
r=b-a*x0;
p=r;
while iter<nitmax & err>toll
	ap=a*p;
 	pap=p'*ap;
	alfa=p'*r/pap;
        x=x0+alfa*p;
	r=r-alfa*ap;
	beta=ap'*r/pap;
	p=r-beta*p;
        err= norm(x-x0);
        iter=iter+1;
        x0=x; 
end
if iter==nitmax & err>toll
        disp('non converge nel numero di iterazioni assegnato')
end

