function [x,iter]=jacobi(a,b,x0,toll,nitmax)
% Help function jacobi
% 
% [x,iter]=jacobi(a,b,x0,toll,nitmax)
%
% Metodo di jacobi per sistemi lineari
%
% Parametri ingresso: 
%
%       a       matrice del sistema
%       b       termine noto del sistema (vettore colonna)
%       x0      vettore iniziale
%       toll    tolleranza sul test d'arresto (differenza iterate)
%       nitmax  numero max iterazioni consentite
%
% Parametri uscita:
%
%       x       soluzione approssimata (vettore colonna)       
%       iter    numero iterazioni effettuato
%
d=diag(a);
a=a-diag(diag(a));
iter=0;
err=1;
while iter<nitmax & err>toll
        x=(-a*x0+b)./d;
        err= norm(x-x0);
        iter=iter+1;
        x0=x; 
end
if iter==nitmax & err>toll
        disp('non converge nel numero di iterazioni assegnato')
end

