function [l,iter]=potenza(a,x,toll,nitmax)
% Help function potenza
% 
% [l,iter]=potenza(a,x,toll,nitmax)
%
% Metodo della potenza per calcolo autovalore di mod. max
% con normalizzazione
%
% Parametri ingresso: 
%
%       a       matrice 
%       x       vettore iniziale
%       toll    tolleranza sul test d'arresto (differenza iterate)
%       nitmax  numero max iterazioni consentite
%
% Parametri uscita:
%
%       l       autovalore di mod max       
%       iter    numero iterazioni effettuato
%
[nor,ind]=max(abs(x));
l0=x(ind);
x=x/nor;
i=0;
while i<nitmax
        x=a*x;
        [nor,ind]=max(abs(x));
        l=x(ind);
        if abs(l-l0)<toll
                iter=i;
                i=nitmax+1;
        else
                x=x/nor;
                l0=l;
                i=i+1;
        end
end
if i==nitmax
        disp('non converge nel numero di iterazioni assegnato')
end

