function [x,iter]=richard(a,b,x0,toll,nitmax)
% Help function richard
% 
% [x,iter]=richard(a,b,x0,toll,nitmax)
%
% Metodo di Richardson per sistemi lineari- si blocca se A non e'simm def pos
%
% Parametri ingresso: 
%
%       a       matrice del sistema
%       b       termine noto del sistema (vettore colonna)
%       x0      vettore iniziale
%       toll    tolleranza sul test d'arresto (differenza iterate)
%       nitmax  numero max iterazioni consentite
%
% Parametri uscita:
%
%       x       soluzione approssimata (vettore colonna)       
%       iter    numero iterazioni effettuato
%
if norm(a-a')>0
	disp('matrice non simm. non uso metodo Rich.')
	break
end
l=eig(a);
lmin=min(l);
lmax=max(l);
if lmin <= 0
	disp('matrice non def. positiva')
	break
end
gamma=2/(lmin+lmax);
n=max(size(a));
h=eye(n)-gamma*a;
k=gamma*b;
iter=0;
err=1;
while iter<nitmax & err>toll
        x=h*x0+k;
        err= norm(x-x0);
        iter=iter+1;
        x0=x; 
end
if iter==nitmax & err>toll
        disp('non converge nel numero di iterazioni assegnato')
end

